<!DOCTYPE html">

<html lang=en>
  <title>CNC Machine</title>

  <style type="text/css">

/* Tabbed example */
div.tabs {
  min-height: 50em;		/* height: */
  position: relative;	/* Establish a containing block */
  line-height: 1;		/* Easier to calculate with */
  z-index: 0}			/* So we can place things behind */
div.tabs > div {
  display: inline}		/* We want buttons on one line */
div.tabs > div > a {
  color: black;			/* Looks like a button than a link */
  background: #CCC;		/* Active tabs are light gray */
  padding: 0.2em;		/* Some breathing space */
  border: 0.1em outset #BBB;	/* Make it look like a button */
  border-bottom: 0.1em solid #CCC} /* connect tab with body */
div.tabs > div:not(:target) > a {
  border-bottom: none;	/* Make bottom border disappear */
  background: #999}		/* Inactive tabs are dark gray */
div.tabs > div:target > a,	/* Apply to the targeted item */
:target #default2 > a {	/* ... to the default item */
  border-bottom: 0.1em solid #CCC; /* connect tab with body */
  background: #CCC}		/* Active tab is light gray */
div.tabs > div > div {
  background: #CCC;		/* Light gray */
  z-index: -2;			/* Behind, because borders overlap */
  left: 0; top: 1.3em;	/* Top needs some calculation... */
  bottom: 0; right: 0;	/* Sides flush with container */
  overflow: auto;		/* Scroll bar if needed */
  padding: 0.3em;		/* Looks better */
  border: 0.1em outset #BBB}	/* 3D look */
div.tabs > div:not(:target) > div { /* Protect CSS1&2 browsers */
  position: absolute }	/* All these divs overlap */
div.tabs > div:target > div, :target #default2 > div {
  position: absolute;	/* All these divs overlap */
  z-index: -1}			/* Raise it above the others */

div.tabs :target {
  outline: none}
</style>
 

<body>

  <div class=section id=tabs>

<?php //________________Main page_______________________?>

   <h2>CNC Machine</h2>
    <div class=tabs>
     <div id=tab1> <a href="#tab1">Main</a>
      <div>
		<?php
//Read GRBL parameters into $status
		$status = shell_exec("/usr/terminal/terminal" 
		. " '$$' " . $status . " 2>&1");
		$error = substr($status, 0, 5);
		if($error == "error"){
			echo "<p>You can't change GRBL parameters while the motors are running!</p>";
		}
//Parse GRBL parameters for $0 step pulse setting
		$start=stripos($status, "$0=");	//find string start
		$grbl0=substr($status, $start);	//strip after character
		$length=stripos($grbl0, " ");	//line length
		$grbl0=substr($grbl0, 3, $length-3);
		echo "<p>The GRBL step pulse is $grbl0</p>";
		if(!$_POST['step_pulse']){
			$varStep_pulse = $grbl0;
		}else{
			$varStep_pulse = $_POST['step_pulse'];
		}

//Parse GRBL parameters for $1 step idle setting
		$start=stripos($status, "$1=");	//find string start
		$grbl1=substr($status, $start);	//strip after character
		$length=stripos($grbl1, " ");	//line length
		$grbl1=substr($grbl1, 3, $length-3);
		echo "<p>The GRBL step idle is $grbl1</p>";
		if(!$_POST['step_idle']){
			$varStep_idle = $grbl1;
		}else{
			$varStep_idle = $_POST['step_idle'];
		}
		
//Parse GRBL parameters for $13 units setting
		$start=stripos($status, "$13=");//find string start
		$grbl13=substr($status, $start);//strip after character
		$length=stripos($grbl13, " ");	//line length
		$grbl13=substr($grbl13, 4, $length-4);
		echo "<p>The GRBL units boolean is $grbl13</p>";
		if(!$_POST['Units']){
			$varUnits = $grbl13;
		}else{
			$varUnits = $_POST['Units'];
		}

//Parse GRBL parameters for $110 max rate setting
		$start=stripos($status, "$110=");//find string start
		$grbl110=substr($status, $start);//strip after character
		$length=stripos($grbl110, " ");	//line length
		$grbl110=substr($grbl110, 4, $length-4);
		echo "<p>The GRBL max rate is $grbl110</p>";

//Parse GRBL parameters for $120 max acceleration setting
		$start=stripos($status, "$120=");//find string start
//echo "<br>start is $start</br>";
		$grbl120=substr($status, $start);//strip after character
//echo "<br>status after strip $status</br>";
		$length=stripos($grbl120, " ");	//line length
//echo "<br>length $length</br>";
		$grbl120=substr($grbl120, 4, $length-4);
		echo "<p>The GRBL max acceleration is $grbl120</p>";

//Parse GRBL parameters for $130 the x axis extent
		$xtent=stripos($status, "$130=");
		$grbl130=substr($status, $xtent);
		$grbl_xtent=stripos($grbl130, " ");
		$grbl130=substr($grbl130, 4, 5);
		echo "<p>The GRBL x extent is $grbl130</p>";

		?>

		<b>Position</b>
		<p>
		<?php 
			$position = shell_exec("/usr/terminal/terminal" 
			. " ?"." 2>&1");
			echo "<b>$position</b>";
		?>
		</p>
	  </div>
     </div>

<?php //________________X axis__________________________?>

     <div id=tab2> <a href="#tab2">X axis</a>
      <div>
		<?php
		echo "<p>The GRBL max rate is $grbl110</p>";
		echo "<p>The GRBL max accel is $grbl120</p>";
		echo "<p>The GRBL units are  $grbl130</p>";
  		$grbl110 = $_POST['max_rate'];
  		$grbl120 = $_POST['max_accel'];
		$varSteps = $_POST['step_rev'];
		$varTpi = $_POST['tpi'];
		$grbl130 = $_POST['x_extent'];
		$varRun = $_POST['run'];
		$varFwd = $_POST['forward'];
		$varRev = $_POST['reverse'];
		?>

		<b>Motor</b>
		<form method="post">
		<p style="text-indent: 3em;">Steps/revolution
    	<input type="text" name="step_rev" 
		  	value="<?=$varSteps;?>" size = 6 >
		</p>

		<p style="text-indent: 3em;">Stepper Mode
		<select name="mode" onchange='this.form.submit()'>
			<option value="Full" 
				<?php 	
					if ($_POST['mode']=="Full") 
					echo "selected";
				?> 
			>Full
			</option>

			<option value="Half" 
				<?php 	
					if ($_POST['mode']=="Half") 	
					echo "selected";
				?> 
			>Half
			</option>

			<option value="Quarter" 
				<?php 
					if ($_POST['mode']=="Quarter") 
					echo "selected";
				?> 
			>Quarter
			</option>

    		<option value="Eighth" 
				<?php 
					if ($_POST['mode']=="Eighth") 
					echo "selected";
				?> 
			>Eighth
			</option>
		</select>

		<?php 
			if ($_POST['mode']){
				$mode = $_POST['mode'];
				$output = shell_exec("/usr/MCP23008/set_step_mode" 
				. "/set_step_mode other " . $mode . " 2>&1");
				echo "<pre>$output</pre>";
			}
		?>
		</p>

		<p style="text-indent: 3em;">Direction
			<input type="checkbox" name="Direction" 
				value="direction" 
			<?php 
				if ($_POST['Direction']=="direction") 
				echo "checked";
			?> > Invert
		</p>

		<p style="text-indent: 3em;">Maximum rate
    	<input type="text" name="max_rate" 
			value="<?=$grbl110;?>" size = 6 >mm/min
			<?php 
				if ($grbl110){
					shell_exec("/usr/terminal/terminal" 
					. " '$110=$grbl110' " . " 2>&1");
				}
			?>
		</p>
 
    	<p style="text-indent: 3em;">Acceleration
    	<input type="text" name="max_accel" 
			value="<?=$grbl120;?>" size = 6 >mm/(sec**2)
			<?php 
				if ($grbl120){
					shell_exec("/usr/terminal/terminal" 
					. " '$120=$grbl120' " . " 2>&1");
				}
			?>
		</p>
		<input type="submit" name="formSubmit" 
			value="Submit" hidden>

		<p style="text-indent: 3em;">Motor current
		<select name="current" onchange='this.form.submit()'>
    		<option value="0%" 
				<?php 
					if ($_POST['current']=="0%") 
					echo "selected";
				?> >0%</option>
    		<option value="10%" 
				<?php 
					if ($_POST['current']=="10%") 
					echo "selected";
				?> >10%</option>
    		<option value="20%" 
				<?php 
					if ($_POST['current']=="20%") 
					echo "selected";
				?> >20%</option>
    		<option value="30%" 
				<?php 
					if ($_POST['current']=="30%") 
					echo "selected";
				?> >30%</option>
    		<option value="40%" 
				<?php 
					if ($_POST['current']=="40%") 
					echo "selected";
				?> >40%</option>
    		<option value="50%" 
				<?php 
					if ($_POST['current']=="50%") 
					echo "selected";
				?> >50%</option>
    		<option value="60%" 
				<?php 
					if ($_POST['current']=="60%") 
					echo "selected";
				?> >60%</option>
    		<option value="70%" 
				<?php 
					if ($_POST['current']=="70%") 
					echo "selected";
				?> >70%</option>
    		<option value="80%" 
				<?php 
					if ($_POST['current']=="80%") 
					echo "selected";
				?> >80%</option>
    		<option value="90%" 
				<?php 
					if ($_POST['current']=="90%") 
					echo "selected";
				?> >90%</option>
    		<option value="100%" 
				<?php 
					if ($_POST['current']=="100%") 
					echo "selected";
				?> >100%</option>
		</select>
		<?php 
			if ($_POST['current']){
				$current = $_POST['current'];
				$output = shell_exec("/usr/MCP23008/set_motor_current" 
				. "/set_motor_current other " . $current . " 2>&1");
				echo "<pre>$output</pre>";
			}
		?>
		</p>

		<b>Machine</b>

		<p style="text-indent: 3em;">Lead screw 
    	<input type="text" name="tpi" 
			value="<?=$varTpi;?>" size = 6 > tpi
		</p>

		<p style="text-indent: 3em;">Limit
		<input type="radio" name="limit" value="min" 
			<?php 
				if ($_POST['limit']=="min") 
				echo "checked";
			?> 
		> min

		<input type="radio" name="limit" value="max" 
			<?php 
				if ($_POST['limit']=="max") 
				echo "checked";
			?> 
		> max
		</p>

    	<p style="text-indent: 3em;">Axis travel
    	<input type="text" name="x_extent" 
			value="<?=$grbl130;?>" size = 6 > mm
		<?php 
			if ($grbl130){
				shell_exec("/usr/terminal/terminal" 
				. " '$130=$grbl130' " . " 2>&1");
			}
		?>
		</p>

		<b>Test</b>
		<p style="text-indent: 3em;">Limits
		<input type="text" name="run" value = "0"
			value="<?=$varRun;?>" size = 6 > 
		
		<?php 
			if ($_POST['run']=="1"){
				$output = shell_exec("/usr/terminal/terminal" 
				. " \"G01 Z10 F260\" " . $output . " 2>&1");
				echo "<pre>$output</pre>";
				$output1 = shell_exec("/usr/terminal/terminal" 
				. " \"G01 Z-10 F260\" " . $output1 . " 2>&1");
				echo "<pre>$output1</pre>";
			}
		?>
		</p>
		<p style="text-indent: 3em;">Forward
		<input type="text" name="forward" value="0" 
			value="<?=$varForward;?>" size = 6 >  
		<?php 
			if ($_POST['forward']=="1"){
				$output2 = shell_exec("/usr/terminal/terminal" 
				. " \"G01 Z10 F260\" " . $output2 . " 2>&1");
				echo "<pre>$output2</pre>";
			}
		?>
		</p>

		<p style="text-indent: 3em;">Reverse
		<input type="text" name="reverse" value="0" 
			value="<?=$varReverse;?>" size = 6 > 
		<?php 
			if ($_POST['reverse']=="1"){
				$position1 = shell_exec('/usr/terminal/terminal');
				$output3 = shell_exec("/usr/terminal/terminal" 
				. " \"G01 Z-10 F260\" ". $output3 . " 2>&1");
				echo "<pre>$output3</pre>";
				echo "<pre>$position1</pre>";
			}
		?>
		</p>

		</form>
	  </div>
     </div>

<?php //________________Y axis__________________________?>

     <div id=tab3> <a href="#tab3">Y axis</a>
      <div>This is a tab for the Y axis control
	  </div>
     </div>

<?php //________________Z axis__________________________?>

     <div id=tab4> <a href="#tab4">Z axis</a>
      <div>This is a tab for the Z axis control
	  </div>
     </div>

<?php //________________GRBL parameters_________________?>
     <div id=tab5> <a href="#tab5">GRBL</a>
      <div>

		<form method="post">
		<b>Units</b>
		<input type="radio" name="Units" value="Inches"
		 <?php 
			if($varUnits == "Inches"){
				echo "checked";
				shell_exec("/usr/terminal/terminal" 
				. " '$13=1' " . " 2>&1");
			} 
		 ?> 
		> Inches

		<input type="radio" name="Units" value="Millimeters"
		 <?php 
			if($varUnits == "Millimeters"){
				echo "checked";
				shell_exec("/usr/terminal/terminal" 
				. " '$13=0' " . " 2>&1");
			} 
		 ?> 
		> Millimeters	
 
		<p style="text-indent: 3em;">Step pulse 
    	<input type="text" name="step_pulse" 
			value="<?=$varStep_pulse;?>" size = 6 > usec
		 <?php 
			if ($varStep_pulse){
				shell_exec("/usr/terminal/terminal" 
				. " '$0=$varStep_pulse' " . " 2>&1");
			}
		 ?>
		</p>

		<p style="text-indent: 3em;">Step idle delay 
    	<input type="text" name="step_idle" 
			value="<?=$varStep_idle;?>" size = 6 >  msec
		 <?php 
			if ($varStep_idle){
				shell_exec("/usr/terminal/terminal" 
				. " '$1=$varStep_idle' " . " 2>&1");
			}
		 ?>
		</p>
		<input type="submit" name="formGRBL" 
			value="Submit" hidden>
		</form>
	  </div>
     </div>

<?php //________________Firmware__________________________?>

     <div id=main> <a href="#main">Firmware</a>
	    <div id="script-warning" 
			class="ui-widget-content ui-corner-all" 
			style="padding:5px;">
			<h2>Upgrade GRBL firmware</h2>

			<p>Current GRBL Version  
			<?php 
				$version = shell_exec("/usr/terminal/terminal" 
				. " '\$i' " . $version . " 2>&1");
				echo "<pre>$version</pre>";
			?>
			</p>

			<div style="padding: 15px 0;">
				<form action="program_arduino.php" 
					method="post" 
					enctype="multipart/form-data">
				<label for="file">Filename:</label>
				<input type="file" name="file" 
					id="file" />
				<input type="submit" name="Program" 
					value="Program" />
				</form>
			</div>
		</div>
	 </div>	
	</div>	 
</body>
 
 
